;==================================
; LOADPROF - Matt Pietrek 1994
; FILE: INT.ASM
;==================================
.model large
.286

extrn INT3HANDLER : FAR

.code

public _LoadProf_IntHandler

_LoadProf_IntHandler proc
    enter   0, 0
    pusha

    cmp     WORD PTR [bp+08], 3     ; examine interrupt number
    jne     continue_search

    push    ds                      ; Save original DS and switch to
    push    es                      ; LoadProf's
    mov     ds,ax

    mov     ax,[bp+6]               ; copy the AX that TH saved into the
    mov     [bp-02],ax              ; AX slot in the pusha frame

    push    [bp+0Eh]                ; push faulting CS
    push    [bp+0Ch]                ; push faulting IP
    push    SS                      ; push faulting SS
    lea     ax, [bp+12h]
    push    AX                      ; push faulting SP
    call    INT3HANDLER

    pop     es
    pop     ds                      ; Restore original DS
    or      ax,ax           ; If INT3HANDLER returns 0, goto continue_search
    jz      continue_search ; otherwise, fall through to restart_instruction

restart_instruction:
    dec     WORD PTR [bp+0Ch] ; back up IP to where we put the original opcode
    popa
    leave
    add     sp, 10
    iret

continue_search:
    popa
    leave
    retf
_LoadProf_IntHandler endp

end
